"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.persistStorage = exports.listAllActions = exports.readAction = exports.writeAction = undefined;

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncIterator2 = require("babel-runtime/helpers/asyncIterator");

var _asyncIterator3 = _interopRequireDefault(_asyncIterator2);

var _asyncGenerator2 = require("babel-runtime/helpers/asyncGenerator");

var _asyncGenerator3 = _interopRequireDefault(_asyncGenerator2);

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _jsonfile = require("jsonfile");

var _jsonfile2 = _interopRequireDefault(_jsonfile);

var _mkdirp = require("mkdirp");

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _reduxPersistNodeStorage = require("redux-persist-node-storage");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cacheFolder = process.env.JEC_JASK_CACHE_FOLDER || require("os").homedir() + "/.jecJaskCache";
var actionFolder = process.env.JEC_ACTIONS_FOLDER || require("os").homedir() + "/.jecActions";

var ensureActionFolderExists = function ensureActionFolderExists() {
	return new Promise(function (done, fail) {
		(0, _mkdirp2.default)(actionFolder, function (err) {
			return err ? fail(err) : done();
		});
	});
};

var writeAction = exports.writeAction = function writeAction(action) {
	return ensureActionFolderExists().then(function () {
		return new Promise(function (done, fail) {
			_jsonfile2.default.writeFile(actionFolder + "/" + action.timestamp + "_" + action.type + "_" + action.salt, action, function (err) {
				return err ? fail(err) : done();
			});
		});
	});
};

var readAction = exports.readAction = function readAction(id) {
	return ensureActionFolderExists().then(function () {
		return new Promise(function (done, fail) {
			_jsonfile2.default.readFile(actionFolder + "/" + id, function (err, dat) {
				return err ? fail(err) : done(dat);
			});
		});
	});
};

var wrappedGetFiles = function wrappedGetFiles() {
	return ensureActionFolderExists().then(function () {
		return new Promise(function (done, fail) {
			_fs2.default.readdir(actionFolder, function (err, files) {
				return err ? fail(err) : done(files || []);
			});
		});
	});
};

var listAllActions = exports.listAllActions = function () {
	var _ref = _asyncGenerator3.default.wrap( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
		var files, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _value, id;

		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						_context.next = 2;
						return _asyncGenerator3.default.await(wrappedGetFiles());

					case 2:
						files = _context.sent;
						_iteratorNormalCompletion = true;
						_didIteratorError = false;
						_iteratorError = undefined;
						_context.prev = 6;
						_iterator = (0, _asyncIterator3.default)(files);

					case 8:
						_context.next = 10;
						return _asyncGenerator3.default.await(_iterator.next());

					case 10:
						_step = _context.sent;
						_iteratorNormalCompletion = _step.done;
						_context.next = 14;
						return _asyncGenerator3.default.await(_step.value);

					case 14:
						_value = _context.sent;

						if (_iteratorNormalCompletion) {
							_context.next = 22;
							break;
						}

						id = _value;
						_context.next = 19;
						return id;

					case 19:
						_iteratorNormalCompletion = true;
						_context.next = 8;
						break;

					case 22:
						_context.next = 28;
						break;

					case 24:
						_context.prev = 24;
						_context.t0 = _context["catch"](6);
						_didIteratorError = true;
						_iteratorError = _context.t0;

					case 28:
						_context.prev = 28;
						_context.prev = 29;

						if (!(!_iteratorNormalCompletion && _iterator.return)) {
							_context.next = 33;
							break;
						}

						_context.next = 33;
						return _asyncGenerator3.default.await(_iterator.return());

					case 33:
						_context.prev = 33;

						if (!_didIteratorError) {
							_context.next = 36;
							break;
						}

						throw _iteratorError;

					case 36:
						return _context.finish(33);

					case 37:
						return _context.finish(28);

					case 38:
					case "end":
						return _context.stop();
				}
			}
		}, _callee, this, [[6, 24, 28, 38], [29,, 33, 37]]);
	}));

	function listAllActions() {
		return _ref.apply(this, arguments);
	}

	return listAllActions;
}();

var persistStorage = exports.persistStorage = new _reduxPersistNodeStorage.AsyncNodeStorage(cacheFolder);