"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.parseRecur = exports.parseFrom = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _ramda = require("ramda");

var R = _interopRequireWildcard(_ramda);

var _dateFns = require("date-fns");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var extractNumber = function extractNumber(adder, ref) {
	return R.pipe(R.match(/\d+/), R.head, function (x) {
		return parseInt(x, 10);
	}, function (x) {
		return adder(ref, x);
	});
};

var parseFrom = exports.parseFrom = function parseFrom(ref) {
	return R.cond([[R.test(/\d+d/), extractNumber(_dateFns.addDays, ref)], [R.test(/\d+w/), extractNumber(_dateFns.addWeeks, ref)], [R.test(/\d+m/), extractNumber(_dateFns.addMonths, ref)], [R.test(/\d+y/), extractNumber(_dateFns.addYears, ref)], [R.test(/^eod$/), function () {
		return (0, _dateFns.endOfDay)(ref);
	}], [R.test(/^eom$/), function () {
		return (0, _dateFns.endOfMonth)(ref);
	}], [R.test(/^eow$/), function () {
		return (0, _dateFns.endOfWeek)(ref);
	}], [R.test(/^eoy$/), function () {
		return (0, _dateFns.endOfYear)(ref);
	}], [R.test(/^sod$/), function () {
		return (0, _dateFns.startOfDay)(ref);
	}], [R.test(/^som$/), function () {
		return (0, _dateFns.startOfMonth)(ref);
	}], [R.test(/^sow$/), function () {
		return (0, _dateFns.startOfWeek)(ref);
	}], [R.test(/^soy$/), function () {
		return (0, _dateFns.startOfYear)(ref);
	}], [R.test(/^now$/), function () {
		return ref;
	}]]);
};

exports.default = parseFrom(new Date());
var parseRecur = exports.parseRecur = R.pipe(R.match(/(\d+)([dwmy])/), function (_ref) {
	var _ref2 = (0, _slicedToArray3.default)(_ref, 3),
	    _ = _ref2[0],
	    n = _ref2[1],
	    period = _ref2[2];

	return {
		n: parseInt(n, 10),
		period: period
	};
});